#!/usr/bin/perl

#######################################################
#	Exibia 2 Installer
#
	$installer_version = "v2.1"; 
	$build = "180";
#
#	Date:		12.05.10
#######################################################

#######################################################
## First, remove the old crud (but not the important stuff)
## This will remove the Exibia 1.x files that will be replaced by 
## Newer 2.0 components

## MAKE SURE TO REMOVE THE DEBUG COMMENTING SO THUMBS ARE GENERATED!!
$debug = "no";

$on_step = 0;
$install_log_date = "exibia2install_" . time;

$filefive = $ARGV[0];
$filefive =~ s/ /\\ /gi;

`rm /tmp/exibia2progress_start.txt`;
`rm /tmp/exibia2progress_finish.txt`;

$start_time = $ARGV[1];

$temp_from = "exibia";	## CHANGE
$temp_to = "exibia";	## CHANGE 

if (-e "/library/webserver/cgi-executables/$temp_from/localmovies.txt") {
	
	open(README, "/library/webserver/cgi-executables/$temp_from/localmovies.txt");
	@lclmvs = <README>;
	close (README);

	$installer_movie_number = scalar(@lclmvs);
}

$installer_steps = 20 + $installer_movie_number;

open(STATUS, ">/tmp/exibia2progress_start.txt");
print STATUS "$installer_steps";
close (STATUS);

open(STATUS, ">/tmp/exibia2installer.txt");
print STATUS "";
close (STATUS);

# Check to see if Exibia is installed
if (!-e "/library/webserver/cgi-executables/exibia.pl") { &statusUpdate("Beginning Exibia 2.0 Install ($installer_version)"); }
else { &statusUpdate("Beginning Exibia 2.0 Upgrade ($installer_version)"); }

&makeNewDirectories();

&statusUpdate("Cleaning files..."); 

## Attempt to backup Exibia Install
if (-e "/library/webserver/cgi-executables/exibia.pl") {

	($asec,$amin,$ahour,$amday,$amon,$ayear,$awday,$ayday,$isdst) = localtime(time);
	my $year = $ayear+1900; my $month = $amon+1; my $backuptime = "$month" . "$amday" . $year;

	my $backupdir = $backuptime . "_" . &qchar();
	
	`mkdir /library/webserver/cgi-executables/exibia_backups/`;
	`mkdir /library/webserver/cgi-executables/exibia_backups/$backupdir`;
	`cp -R /library/webserver/cgi-executables/exibia/ /library/webserver/cgi-executables/exibia_backups/$backupdir/`;
	&statusUpdate("Backing up existing Exibia configuration files.");
	
}

## Updated in 2.0.2 to force remove exibia_qt and exibia_qt_pic to copy new version

`rm /library/webserver/cgi-executables/exibia/progress_script.js`;
`rm /library/webserver/cgi-executables/exibia_qt`;
`rm /library/webserver/cgi-executables/exibia_qt_pic`;
`rm /library/webserver/cgi-executables/exibia.pl`;
`rm /library/webserver/cgi-executables/exibiaupload.pl`;
`rm /library/webserver/cgi-executables/exibiauploadconfig.pm`;
`rm /library/webserver/cgi-executables/exibiawebupload.pl`;
`rm /library/webserver/cgi-executables/progress.pl`;
`rm /library/webserver/cgi-executables/scheduler.pl`;
`rm /library/webserver/cgi-executables/uploadfinished.pl`;


#######################################################
## Second, lets update the exibiasettings.pl file to reflect the new datapath
## This was from an earlier updater of Exibia 1.x - Keep just in case

## Install settings if they don't exist
if (!-e "/library/webserver/cgi-executables/exibiasettings.pl")
{	`cp $filefive/exibiasettings.pl /library/webserver/cgi-executables/`; }

if (!-e "/library/webserver/documents/exibia/exibia.ics") {
`touch /library/webserver/documents/exibia/exibia.ics`;
}

$my_datapath_value = "datapath = \"exibia\"";
$new_datapath_value = "\t\$datapath = \"/library/webserver/cgi-executables/exibia\";\n";

# Read the settings file
open(READ, "/library/webserver/cgi-executables/exibiasettings.pl");
@old_settings_array = <READ>;
close (READ);

# Back up the settings file
open(BACKUP, ">/library/webserver/cgi-executables/exibiasettings-previous.pl");
print BACKUP @old_settings_array;
close (BACKUP);

$july = "July 11th"; $sept = "September 3rd";

## 2.0.0 upgrade password fix
foreach $two_line (@old_settings_array) {
	$nltp = $two_line;
	
	## Skip if we've already done this - new in 2.0.2 // 171
	if ($two_line =~ m/$july/) { @new_old_settings_array = @old_settings_array; last; }
	if ($two_line =~ m/$sept/) { @new_old_settings_array = @old_settings_array; last; }
	
	if ($two_line =~ m/server_pw/) { $nltp = "\t\$server_pw = \"ex1b1a!\";\n";  }
	if ($two_line =~ m/server_un/) { $nltp = "\t\$server_un = \"Exibia Administrator\";\n";  }
	if ($two_line =~ m/Last Update/) { $nltp = "#\tLast Updated:\tSeptember 3rd, 2010\n";  }
	push (@new_old_settings_array,$nltp);
	next;
}

# Write new settings file
open(NEWCONFIG, ">/library/webserver/cgi-executables/exibiasettings_2.pl");
foreach $line (@new_old_settings_array) {
	if ($line =~ m/$my_datapath_value/) { print NEWCONFIG "\t\$datapath = \"/library/webserver/cgi-executables/exibia\";\n"; }
	else	{ print NEWCONFIG $line; }
}
close (NEWCONFIG);

# Remove previous settings
`rm /library/webserver/cgi-executables/exibiasettings.pl`; 
# Copy new settings to exibiasettings.pl
`cp /library/webserver/cgi-executables/exibiasettings_2.pl /library/webserver/cgi-executables/exibiasettings.pl`;
# Remove exibiasettings_2.pl file
`rm /library/webserver/cgi-executables/exibiasettings_2.pl`; 



#######################################################
## Third, install the new web executables


$arch = `arch`;

if ($arch =~ m/ppc/) { $archdir = "ppc"; }
if ($arch =~ m/i386/) { $archdir = "intel"; }

&statusUpdate("Installing Exibia 2 Files"); 

$preflight = "/library/webserver/cgi-executables/exibiawebupload.pl";
$syntax = "/library/webserver/cgi-executables/exibia.pl";
$sched = "/library/webserver/cgi-executables/scheduler.pl";
$post = "/library/webserver/cgi-executables/exibiaupload.pl";


`cp /library/webserver/cgi-executables/exibiauploadconfig.pm .`;

$sl = "perlcc"; $sl = "perlcc5.8.9" if (`sw_vers -productVersion` =~ m/10.6/);
$path = "-pass"; $operand = "file";  $sed = "openssl"; $filesize = "salt"; $datapath = "des3";
@files_to_install = ("exibia.pl", "exibiaupload.pl" , "exibiawebupload.pl" , "uploadfinished.pl" , "progress.pl", "exibiapicupload.pl");

`cp $filefive/exibiauploadconfig.pm /library/webserver/cgi-executables/`;
`cp $filefive/scheduler.pl /library/webserver/cgi-executables/scheduler.pl`;
`chmod 755 /library/webserver/cgi-executables/exibiauploadconfig.pm`;
`chown www /library/webserver/cgi-executables/exibiauploadconfig.pm`;
`chmod +x /library/webserver/cgi-executables/exibiauploadconfig.pm`;

$periods = ".";

foreach $filename (@files_to_install) { 
	$periods = $periods . ".";
	&statusUpdate("Installing Exibia 2 Files $periods"); 
	`$sed $datapath -d $path $operand:$sched -$filesize -in $filefive/un-$filename -out /library/webserver/cgi-executables/sp-$filename`;
	`cd /library/webserver/cgi-executables/ ; $sl -B -o $filename sp-$filename `;
	`rm /library/webserver/cgi-executables/sp-$filename`;
	`chmod 755 /library/webserver/cgi-executables/$filename`;
	`chown www /library/webserver/cgi-executables/$filename`;
	`chmod +x /library/webserver/cgi-executables/$filename`;
}

`cp $filefive/progress_script.pl /library/webserver/cgi-executables/exibia/`;
`cp "/library/webserver/cgi-executables/exibia/progress_script.pl" "/library/webserver/cgi-executables/exibia/progress_script.js"`;
`rm "/library/webserver/cgi-executables/exibia/progress_script.pl"`;
`chmod 755 /library/webserver/cgi-executables/exibia/progress_script.js`;
`chown www /library/webserver/cgi-executables/exibia/progress_script.js`;
`chmod +x /library/webserver/cgi-executables/exibia/progress_script.js`;


if (!-e "/library/webserver/cgi-executables/exibia_qt") { 
	`cp $filefive/exibia_qt /library/webserver/cgi-executables/`;
	`chmod 4777 /library/webserver/cgi-executables/exibia_qt`;
	`chown root /library/webserver/cgi-executables/exibia_qt`;
	`chmod +x /library/webserver/cgi-executables/exibia_qt`;
}

&statusUpdate("Installing Exibia 2 Web Images"); 

# if (!-e "/library/webserver/cgi-executables/exibia/installed.txt") { 
`cp $filefive/exibiaweb.jpg /library/webserver/documents/exibia/`;

## CHANGE BEFORE 2.0 FINAL
`cp $filefive/index.html /library/webserver/documents/`;
`cp $filefive/index.html /library/webserver/documents/exibia/`;
`cp $filefive/index.html /library/webserver/documents/icons/`;
`cp $filefive/audio.gif /library/webserver/documents/exibia/`;
`cp $filefive/image.gif /library/webserver/documents/exibia/`;
`cp $filefive/movies.gif /library/webserver/documents/exibia/`;
`cp $filefive/quicktime.gif /library/webserver/documents/exibia/`;
`cp $filefive/windowsmedia.gif /library/webserver/documents/exibia/`;

#	New icons for 1.1.6
`cp $filefive/ical.png /library/webserver/documents/exibia/icons/`;
`cp $filefive/exibiamenu.png /library/webserver/documents/exibia/icons/`;
`cp $filefive/info.png /library/webserver/documents/exibia/icons/`;
`cp $filefive/schedule.png /library/webserver/documents/exibia/icons/`;
`cp $filefive/logout.png /library/webserver/documents/exibia/icons/`;
`cp $filefive/search.png /library/webserver/documents/exibia/icons/`;
`cp $filefive/description.png /library/webserver/documents/exibia/icons/`;
`cp $filefive/tag.png /library/webserver/documents/exibia/icons/`;
`cp $filefive/upload.png /library/webserver/documents/exibia/icons/`;
#	New icons for 1.2.2
`cp $filefive/red.png /library/webserver/documents/exibia/icons/`;
`cp $filefive/green.png /library/webserver/documents/exibia/icons/`;
`cp $filefive/leftarrow.png /library/webserver/documents/exibia/icons/`;
`cp $filefive/rightarrow.png /library/webserver/documents/exibia/icons/`;
`cp $filefive/exibia_iphone_icon.png /library/webserver/documents/exibia/`;
`cp $filefive/exibiaiphone.png /library/webserver/documents/exibia/`;
`cp $filefive/pinstripes.png /library/webserver/documents/exibia/`;
`cp $filefive/qt_sm.png /library/webserver/documents/exibia/`;
#	New icons for 1.3.6
`cp $filefive/play_sm.png /library/webserver/documents/exibia/icons/`;
`cp $filefive/play.png /library/webserver/documents/exibia/icons/`;

`cp $filefive/exibia.css /library/webserver/documents/exibia/`;
`cp $filefive/iphone.css /library/webserver/documents/exibia/`;	
`cp $filefive/qt.png /library/webserver/documents/exibia/`;
`cp $filefive/remove.png /library/webserver/documents/exibia/`;
`cp $filefive/exibiaweb07.jpg /library/webserver/documents/exibia/`;
# }

`chmod -R 775 /library/webserver/documents/exibia`;
`chown -R www /library/webserver/documents/exibia`;
`chown www /library/webserver/documents/exibia/exibia.ics`;
`chmod 775 /library/webserver/documents/exibia/exibia.ics`;
`chown www /library/webserver/documents/exibia/exibia.css`;
`chmod 775 /library/webserver/documents/exibia/exibia.css`;
`chmod -R 775 /library/webserver/cgi-executables/exibia/`;
`chown -R www /library/webserver/cgi-executables/exibia/`;
`chmod -R 775 /library/webserver/documents/exibia/movies`;
`chgrp -R admin /library/webserver/documents/exibia/movies`;
`chown -R www /library/webserver/documents/exibia/movies`;
`chmod -R 775 /library/webserver/documents/exibia/movies/temp`;
`chgrp -R admin /library/webserver/documents/exibia/movies/temp`;
`chown -R www /library/webserver/documents/exibia/movies/temp`;



#######################################################
## Fourth, start moving in new 2.0 files

&statusUpdate("Installing Exibia 2 files...");

if (!-e "/library/webserver/cgi-executables/exibia_qt_pic") { 
	`cp $filefive/exibia_qt_pic /library/webserver/cgi-executables/`;
	`chmod 4777 /library/webserver/cgi-executables/exibia_qt_pic`;
	`chown root /library/webserver/cgi-executables/exibia_qt_pic`;
	`chmod +x /library/webserver/cgi-executables/exibia_qt_pic`;
}

# Allow Exibia to figure out how many screens are available
`chmod 4777 /usr/sbin/system_profiler`;

`cp $filefive/exibia.css /library/webserver/documents/exibia/`;
`cp $filefive/exibiaweb010.jpg /library/webserver/documents/exibia/`;

# New in 2.0.2 // 177 to fix settings being overwritten
if (!-e "/library/webserver/cgi-executables/exibia/exibiasettings_two.pl") { 
	`cp $filefive/exibiasettings_two.pl /library/webserver/cgi-executables/exibia/`;
}

`cp $filefive/alert_16.png /library/webserver/documents/exibia/icons`;
`cp $filefive/alert_32.png /library/webserver/documents/exibia/icons`;
`cp $filefive/copydays_16.png /library/webserver/documents/exibia/icons`;
`cp $filefive/copydays_32.png /library/webserver/documents/exibia/icons`;
`cp $filefive/removebig.png /library/webserver/documents/exibia/icons`;
`cp $filefive/external_server_sm.png /library/webserver/documents/exibia/icons`;
`cp $filefive/external_server.png /library/webserver/documents/exibia/icons`;
`cp $filefive/exibiaweb010.jpg /library/webserver/documents/exibia/icons`;
`cp $filefive/myexibia_sm.png /library/webserver/documents/exibia/icons`;
`cp $filefive/progress.gif /library/webserver/documents/exibia/icons`;
`cp $filefive/exibia_24.png /library/webserver/documents/exibia/icons`;
`cp $filefive/exibia_48.png /library/webserver/documents/exibia/icons`;
`cp $filefive/exibia_64.png /library/webserver/documents/exibia/icons`;
`cp $filefive/exibia_96.png /library/webserver/documents/exibia/icons`;
`cp $filefive/exibia_128.png /library/webserver/documents/exibia/icons`;
`cp $filefive/newupload_sm.png /library/webserver/documents/exibia/icons`;
`cp $filefive/newupload.png /library/webserver/documents/exibia/icons`;
`cp $filefive/upload_3.png /library/webserver/documents/exibia/icons`;
`cp $filefive/upload_2.png /library/webserver/documents/exibia/icons`;
`cp $filefive/archive.png /library/webserver/documents/exibia/icons`;
`cp $filefive/restart.png /library/webserver/documents/exibia/icons`;
`cp $filefive/schedule_sm.png /library/webserver/documents/exibia/icons`;
`cp $filefive/description_sm.png /library/webserver/documents/exibia/icons`;
`cp $filefive/info_sm.png /library/webserver/documents/exibia/icons`;
`cp $filefive/playlist_sm.png /library/webserver/documents/exibia/icons`;
`cp $filefive/playlist.png /library/webserver/documents/exibia/icons`;
`cp $filefive/search_sm.png /library/webserver/documents/exibia/icons`;
`cp $filefive/music.png /library/webserver/documents/exibia/icons`;
`cp $filefive/bl_music.png /library/webserver/documents/exibia/icons`;
`cp $filefive/yellow.png /library/webserver/documents/exibia/icons`;
`cp $filefive/music.jpg /library/webserver/documents/exibia/icons`;
`cp $filefive/return_sm.png /library/webserver/documents/exibia/icons`;
`cp $filefive/upload_sm.png /library/webserver/documents/exibia/icons`;
`cp $filefive/users.png /library/webserver/documents/exibia/icons`;
`cp $filefive/logs.png /library/webserver/documents/exibia/icons`;
`cp $filefive/playlist8.png /library/webserver/documents/exibia/icons`;
`cp $filefive/import.png /library/webserver/documents/exibia/icons`;
`cp $filefive/settings.png /library/webserver/documents/exibia/icons`;
`cp $filefive/stop.png /library/webserver/documents/exibia/icons`;
`cp $filefive/screensaver.png /library/webserver/documents/exibia/icons`;
`cp $filefive/remove.png /library/webserver/documents/exibia/icons`;
`cp $filefive/folder.png /library/webserver/documents/exibia/icons`;
`cp $filefive/file.png /library/webserver/documents/exibia/icons`;

&statusUpdate("Installing Exibia 2 slides...");

`cp "$filefive/Exibia_001.jpg" /library/webserver/documents/exibia/slides`;
`cp "$filefive/Exibia_002.jpg" /library/webserver/documents/exibia/slides`;
`cp "$filefive/Exibia_003.jpg" /library/webserver/documents/exibia/slides`;
`cp "$filefive/Exibia_004.jpg" /library/webserver/documents/exibia/slides`;
`cp "$filefive/Exibia_005.jpg" /library/webserver/documents/exibia/slides`;
`cp "$filefive/Exibia_006.jpg" /library/webserver/documents/exibia/slides`;
`cp "$filefive/Exibia_007.jpg" /library/webserver/documents/exibia/slides`;
`cp "$filefive/Exibia_008.jpg" /library/webserver/documents/exibia/slides`;
`cp "$filefive/Exibia_009.jpg" /library/webserver/documents/exibia/slides`;
`cp "$filefive/Exibia_010.jpg" /library/webserver/documents/exibia/slides`;
`cp "$filefive/Exibia_011.jpg" /library/webserver/documents/exibia/slides`;
`cp "$filefive/Exibia_012.jpg" /library/webserver/documents/exibia/slides`;

&statusUpdate("Creating Exibia 2 default playlist...");

$rightnow = time;

$defpl = "/library/webserver/cgi-executables/$temp_to/playlists/defaultplaylist.txt";
$lpicdir = "/library/webserver/cgi-executables/$temp_to/localimages.txt";

$slideOne =		"Exibia_001.jpg|/Library/WebServer/Documents/exibia/slides|jpeg|1024x768|Exibia 2.0|$rightnow|127.0.0.1|57000|Exibia 2.0 Slide 001";
$slideTwo =		"Exibia_002.jpg|/Library/WebServer/Documents/exibia/slides|jpeg|1024x768|Exibia 2.0|$rightnow|127.0.0.1|57000|Exibia 2.0 Slide 002";
$slideThree =	"Exibia_003.jpg|/Library/WebServer/Documents/exibia/slides|jpeg|1024x768|Exibia 2.0|$rightnow|127.0.0.1|57000|Exibia 2.0 Slide 003";
$slideFour =	"Exibia_004.jpg|/Library/WebServer/Documents/exibia/slides|jpeg|1024x768|Exibia 2.0|$rightnow|127.0.0.1|57000|Exibia 2.0 Slide 004";
$slideFive =	"Exibia_005.jpg|/Library/WebServer/Documents/exibia/slides|jpeg|1024x768|Exibia 2.0|$rightnow|127.0.0.1|57000|Exibia 2.0 Slide 005";
$slideSix =		"Exibia_006.jpg|/Library/WebServer/Documents/exibia/slides|jpeg|1024x768|Exibia 2.0|$rightnow|127.0.0.1|57000|Exibia 2.0 Slide 006";
$slideSeven =	"Exibia_007.jpg|/Library/WebServer/Documents/exibia/slides|jpeg|1024x768|Exibia 2.0|$rightnow|127.0.0.1|57000|Exibia 2.0 Slide 007";
$slideEight =	"Exibia_008.jpg|/Library/WebServer/Documents/exibia/slides|jpeg|1024x768|Exibia 2.0|$rightnow|127.0.0.1|57000|Exibia 2.0 Slide 008";
$slideNine =	"Exibia_009.jpg|/Library/WebServer/Documents/exibia/slides|jpeg|1024x768|Exibia 2.0|$rightnow|127.0.0.1|57000|Exibia 2.0 Slide 009";
$slideTen =		"Exibia_010.jpg|/Library/WebServer/Documents/exibia/slides|jpeg|1024x768|Exibia 2.0|$rightnow|127.0.0.1|57000|Exibia 2.0 Slide 010";
$slideEleven =	"Exibia_011.jpg|/Library/WebServer/Documents/exibia/slides|jpeg|1024x768|Exibia 2.0|$rightnow|127.0.0.1|57000|Exibia 2.0 Slide 011";
$slideTwelve =	"Exibia_012.jpg|/Library/WebServer/Documents/exibia/slides|jpeg|1024x768|Exibia 2.0|$rightnow|127.0.0.1|57000|Exibia 2.0 Slide 012";

$sl1  = "1|Exibia_001.jpg|/Library/WebServer/Documents/exibia/slides|Exibia 2.0 Slide 001|jpeg|1024x768|image|5|$rightnow";
$sl2  = "2|Exibia_002.jpg|/Library/WebServer/Documents/exibia/slides|Exibia 2.0 Slide 002|jpeg|1024x768|image|5|$rightnow";
$sl3  = "3|Exibia_003.jpg|/Library/WebServer/Documents/exibia/slides|Exibia 2.0 Slide 003|jpeg|1024x768|image|5|$rightnow";
$sl4  = "4|Exibia_004.jpg|/Library/WebServer/Documents/exibia/slides|Exibia 2.0 Slide 004|jpeg|1024x768|image|5|$rightnow";
$sl5  = "5|Exibia_005.jpg|/Library/WebServer/Documents/exibia/slides|Exibia 2.0 Slide 005|jpeg|1024x768|image|5|$rightnow";
$sl6  = "6|Exibia_006.jpg|/Library/WebServer/Documents/exibia/slides|Exibia 2.0 Slide 006|jpeg|1024x768|image|5|$rightnow";
$sl7  = "7|Exibia_007.jpg|/Library/WebServer/Documents/exibia/slides|Exibia 2.0 Slide 007|jpeg|1024x768|image|5|$rightnow";
$sl8  = "8|Exibia_008.jpg|/Library/WebServer/Documents/exibia/slides|Exibia 2.0 Slide 008|jpeg|1024x768|image|5|$rightnow";
$sl9  = "9|Exibia_009.jpg|/Library/WebServer/Documents/exibia/slides|Exibia 2.0 Slide 009|jpeg|1024x768|image|5|$rightnow";
$sl10 = "10|Exibia_010.jpg|/Library/WebServer/Documents/exibia/slides|Exibia 2.0 Slide 010|jpeg|1024x768|image|5|$rightnow";
$sl11 = "11|Exibia_011.jpg|/Library/WebServer/Documents/exibia/slides|Exibia 2.0 Slide 011|jpeg|1024x768|image|5|$rightnow";
$sl12 = "12|Exibia_012.jpg|/Library/WebServer/Documents/exibia/slides|Exibia 2.0 Slide 012|jpeg|1024x768|image|5|$rightnow";

&statusUpdate("Creating Exibia 2 Playlist Files...");

## Make this only happen if the file doesn't exist... or if there is nothing in it! (LATER!)
# Read the settings file
open(PL, "/library/webserver/cgi-executables/exibia/playlists/defaultplaylist.txt");
@pl_array = <PL>;
close (PL);

## Check to make sure these aren't already in the list

if (scalar(@pl_array) < 1) { 
	`echo >>$defpl "$sl1"`; 
	`echo >>$defpl "$sl2"`; 
	`echo >>$defpl "$sl3"`; 
	`echo >>$defpl "$sl4"`;
	`echo >>$defpl "$sl5"`; 
	`echo >>$defpl "$sl6"`; 
	`echo >>$defpl "$sl7"`; 
	`echo >>$defpl "$sl8"`;
	`echo >>$defpl "$sl9"`; 
	`echo >>$defpl "$sl10"`; 
	`echo >>$defpl "$sl11"`; 
	`echo >>$defpl "$sl12"`;
}

## Fix before release - Make sure we're not adding these again each time
# if (!-e "/library/webserver/documents/exibia/slides/Exibia_001.jpg") { 

# Read the settings file
open(DPLS, "$lpicdir");
@default_pl_slide_array = <DPLS>;
close (DPLS);

$n = 0;
my $countslide = 0;

until ($countslide == 12) {

	$countslide++;
	my $write = "yes"; 

	my $count_to_add = $countslide;
	$count_to_add = "0" . $countslide if ($countslide < 10);
	
	my $pic_to_look_for = "Exibia 2.0 Slide 0" . $count_to_add;
	my $pic_to_write = "Exibia_0$count_to_add.jpg|/Library/WebServer/Documents/exibia/slides|jpeg|1024x768|Exibia 2.0|$rightnow|127.0.0.1|57000|Exibia 2.0 Slide 0$count_to_add";

	
	
	foreach my $picline (@default_pl_slide_array) {
		
		if ($picline =~ m/$pic_to_look_for/) { $write = "no"; last; } 
		else { next; }
		
	}
	
	if ($write eq "yes") 	{ `echo >>$lpicdir "$pic_to_write"`; }
	
}
	

#######################################################
## Finally, postflight 

&postFlight();
&statusUpdate("Finishing Exibia install...");

`cp $filefive/index.html /library/webserver/documents/previews/`;
`cp $filefive/index.html /library/webserver/documents/movies/`;
`cp $filefive/index.html /library/webserver/documents/backups/`;

`chmod -R 775 /library/webserver/cgi-executables/$temp_to`;
`chown -R www /library/webserver/cgi-executables/$temp_to`;

`chmod -R 775 /library/webserver/documents/exibia`;
`chown -R www /library/webserver/documents/exibia`;

`chmod -R 775 /library/webserver/cgi-executables/`;
`chown -R www /library/webserver/cgi-executables/`;

## Not sure why this is needed... but it should be 

`chmod -R 775 /library/webserver/cgi-executables/exibiasettings.pl`;
`chown -R www /library/webserver/cgi-executables/exibiasettings.pl`;

`chmod -R 775 /library/webserver/cgi-executables/exibia/exibiasettings_two.pl`;
`chown -R www /library/webserver/cgi-executables/exibia/exibiasettings_two.pl`;

&statusUpdate("Turning on Web Sharing...");
`apachectl start`;

&statusUpdate("Cleaning Up...");
`touch /library/webserver/cgi-executables/exibia/installed.txt`;

open(TOUCHME, ">/library/webserver/cgi-executables/exibia/installed.txt");
print TOUCHME "$installer_version";
close (TOUCHME);

open(STATUS, ">/tmp/exibia2done.txt");
print STATUS "$start_time";
close (STATUS);



&statusUpdate(""); 

exit();

#######################################################
## Subroutine to do upgrade stuff
#######################################################
sub postFlight {
	## This is the postflight stuff... just testing here
	# First, update localmovies.txt
	
	&statusUpdate("Updating Exibia Media...");
	
	# Read Thumbnail Database. 
	open(READ, "/library/webserver/cgi-executables/$temp_to/thumbnail_db.txt") || print("Could not read thumb db file.");
	@loc_tmb_db = <READ>;
	close (READ);
	
	# Read the local movies file
	open(READ, "/library/webserver/cgi-executables/$temp_from/localmovies.txt");
	@local_movies = <READ>;
	close (READ);
	
	my $new_localmovies = "";
	
	my $num_of_movies_to_parse = scalar(@local_movies);
	my $count;
	
	foreach $movie (@local_movies) {
		$count++;
		my @inf = split(/\|/,$movie);
		
		my $number_five,$thumbs,$unique,$qt_file_bytes,$qt_mname_fix,$qt_artist_name,$qt_album_name;
		my $qt_trackname_name, $qt_dimensions_name, $qt_video_format_name, $qt_sampling_rate_name;
		my $qt_audio_bitrate_name, $qt_sound_format_name, $qt_track_number_name, $rightnow;
		my $qt_duration, $qt_medianame, $qt_artist, $qt_album, $qt_trackname, $qt_videosize, $qt_video_format;
		my $qt_sampling_rate, $qt_audio_bitrate, $qt_sound_format, $qt_sound_software,$qt_track_number;
		my @qt_mname, $qt_mname_fix, $qt_dimensions_name, @dimen, $qt_dimensions_name, $track_line, $media_line;
		
		
		# Add Unique ID to the "comment" field
		my $unique = time . "_" . &qchar();
		my $num = scalar(@inf);
		my $new_movie;
		
		$number_five = $inf[5];
		$number_five =~ s/\n//gi;
		$number_five =~ s/\t//gi;
		$number_five =~ s/\r//gi;
		
		my $file_to_look_for = $inf[7];
		$file_to_look_for =~ s/\n//gi;
		$file_to_look_for =~ s/\t//gi;
		$file_to_look_for =~ s/\r//gi;
		
		
		if (-e "/library/webserver/cgi-executables/exibia/content/$file_to_look_for.txt") { 
			
			&statusUpdate("Skipping $inf[0]"); 
			my $old_movie = $movie;
			$old_movie =~ s/\n//gi;
			$old_movie =~ s/\t//gi;
			$old_movie =~ s/\r//gi;
			$new_localmovies = $new_localmovies . $old_movie . "\n";
			next; }
		
		if ($num < 7) {
			$new_movie = "$inf[0]|$inf[1]|$inf[2]|$inf[3]|$inf[4]|$number_five|127.0.0.1|$unique";
		}
		else {
			
		if ($inf[7] =~ m/comment/) { $new_movie = "$inf[0]|$inf[1]|$inf[2]|$inf[3]|$inf[4]|$number_five|$inf[6]|$unique"; }
		else { $new_movie = "$inf[0]|$inf[1]|$inf[2]|$inf[3]|$inf[4]|$number_five|$inf[6]|content"; }
		}
		
		$new_localmovies = $new_localmovies . $new_movie . "\n";
		
		# Create thumbnails
		&statusUpdate("Creating preview images: $inf[0] ($count/$num_of_movies_to_parse)");
		my $thumbs = &createThumbs($inf[0]);
				
		$filename = "/Library/Webserver/Documents/Exibia/Movies/$inf[0]";
		
		if ($debug ne "yes") { 
		$qt_info = "/library/webserver/cgi-executables/./exibia_qt \"$filename\""; @get_qt_info = `$qt_info`;
		}
		
		$qt_file_bytes = (stat ("$filename"))[7];
		$qt_file_bytes = bytes($qt_file_bytes);
		
		foreach my $line (@get_qt_info) 
		{
			if ($line =~ m/track duration/) {		$track_line++; $qt_duration = $line; }
			if ($line =~ m/media file name/) {		$media_line++; $qt_medianame = $line; } 
			if ($line =~ m/Artist/) {				$media_line++; $qt_artist = $line; } 
			if ($line =~ m/Album/) {				$media_line++; $qt_album = $line; } 
			if ($line =~ m/Full Name/) {			$media_line++; $qt_trackname = $line; } 
			if ($line =~ m/width\/height\/depth/) { $media_line++; $qt_videosize = $line; } 
			if ($line =~ m/video format/) {			$media_line++; $qt_video_format = $line; } 
			if ($line =~ m/sampling rate/) {		$media_line++; $qt_sampling_rate = $line; } 
			if ($line =~ m/bits\/channels/) {		$media_line++; $qt_audio_bitrate = $line; } 
			if ($line =~ m/sound format/) {			$media_line++; $qt_sound_format = $line; } 
			if ($line =~ m/Software/) {				$media_line++; $qt_sound_software = $line; } 
			if ($line =~ m/Track/) {				$media_line++; $qt_track_number = $line; } 
			
		}
		
		if ($qt_duration =~ /\:(.*)\(/) {	$file_duration_string = $1; $seconds = int($file_duration_string + 1); }
		if ($qt_medianame =~ /\:(.*)\n/) {	$qt_file_name = $1; }
		if ($qt_artist =~ /\:(.*)\n/) {	$qt_artist_name = $1; }
		if ($qt_album =~ /\:(.*)\n/) {	$qt_album_name = $1; }
		if ($qt_trackname =~ /\:(.*)\n/) {	$qt_trackname_name = $1; }
		if ($qt_videosize =~ /\:(.*)\n/) {	$qt_dimensions_name = $1; }
		if ($qt_video_format =~ /\:(.*)\n/) {	$qt_video_format_name = $1; }
		if ($qt_sampling_rate =~ /\:(.*)\n/) {	$qt_sampling_rate_name = $1; }
		if ($qt_audio_bitrate =~ /\:(.*)\n/) {	$qt_audio_bitrate_name = $1; }
		if ($qt_sound_format =~ /\:(.*)\n/) {	$qt_sound_format_name = $1; }
		if ($qt_sound_software =~ /\:(.*)\n/) {	$qt_sound_software_name = $1; }
		if ($qt_track_number =~ /\:(.*)\n/) {	$qt_track_number_name = $1; }
		
		$qt_sound_format_name =~ s/-//gi;
		$qt_video_format_name =~ s/-//gi;
		
		@qt_mname = split(/\:/,$qt_medianame);
		$qt_mname_fix = $qt_mname[1];
		$qt_mname_fix =~ s/\n//gi;
		
		if ($qt_videosize) {
			$qt_dimensions_name =~ s/\s//gi;
			my @dimen = split /\// , $qt_dimensions_name;
			$qt_dimensions_name = $dimen[0] . "x" . $dimen[1];
			
		}
		
		$rightnow = time;
			
		# End 0.6.0 
		
		# Create that content file
		my $content_file = "/library/webserver/cgi-executables/$temp_to/content/$unique.txt";
		my $content_stuff = "<filename>$inf[0]</filename>
<path>/Library/WebServer/Documents/exibia/movies/</path>
<length>$inf[1]</length>
<uploadedby>$inf[3]</uploadedby>
<size>$inf[4]</size>
<date>$number_five</date>
<ip>$inf[6]</ip>
<thumbs>$thumbs</thumbs>
<id>$unique</id>
<bytes>$qt_file_bytes</bytes>
<mediafilename>$qt_mname_fix</mediafilename>
<artist>$qt_artist_name</artist>
<album>$qt_album_name</album>
<track>$qt_trackname_name</track>
<dimensions>$qt_dimensions_name</dimensions>
<videoformat>$qt_video_format_name</videoformat>		
<samplingrate>$qt_sampling_rate_name</samplingrate>
<audiobitrate>$qt_audio_bitrate_name</audiobitrate>
<soundformat>$qt_sound_format_name</soundformat>		
<soundencoding>$qt_sound_software_name</soundencoding>
<tracknumber>$qt_track_number_name</tracknumber>
<datecontentupdated>$rightnow</datecontentupdated>
<imported>$installer_version</imported>
<description>No description given.</description>";
		
		open(FILE, ">>$content_file") || print"Could not write to content file.";
		print FILE $content_stuff;
		close (FILE);
		
		## Clear out Data
		$number_five = ""; 
		$thumbs = "";
		$unique = "";
		$qt_file_bytes = "";
		$qt_mname_fix = "";
		$qt_artist_name = "";
		$qt_album_name = "";
		$qt_trackname_name = "";
		$qt_dimensions_name = "";
		$qt_video_format_name = "";
		$qt_sampling_rate_name = "";
		$qt_audio_bitrate_name = "";
		$qt_sound_format_name = "";
		$qt_sound_software_name = "";
		$qt_track_number_name = "";
		$rightnow = "";

		$qt_duration = ""; 
		$file_duration_string = "";
		$seconds = "";
		$qt_medianame = ""; 
		$qt_file_name = ""; 
		$qt_artist = "";	
		$qt_artist_name = "";
		$qt_album = "";	
		$qt_album_name = "";
		$qt_trackname = ""; 
		$qt_trackname_name = "";
		$qt_videosize = "";	
		$qt_dimensions_name = "";
		$qt_video_format = "";	
		$qt_video_format_name = "";
		$qt_sampling_rate = "";	
		$qt_sampling_rate_name = "";
		$qt_audio_bitrate = "";	
		$qt_audio_bitrate_name = "";
		$qt_sound_format = "";	
		$qt_sound_format_name = "";
		$qt_sound_software = "";
		$qt_sound_software_name = "";
		$qt_track_number = "";	
		$qt_track_number_name = "";
		
	}
	
	$new_localmovies =~ s/\\n\\n/\\n/gi;
	
	open(FILE, ">/library/webserver/cgi-executables/$temp_to/localmovies.txt") || print"Could not write to new movie file.";
	print FILE $new_localmovies;
	close (FILE);
	
	## Last, update schedule file
	# Read the schedule file
	$schedpath = "/library/webserver/cgi-executables/$temp_to/exibia_schedule.txt";
	
	open(SCHEDULEFILE, $schedpath);
	@sched = <SCHEDULEFILE>;
	close (SCHEDULEFILE);
	
	foreach $scheduled (@sched) {
		
		$local_movie_path = "/Library/WebServer/Documents/exibia/movies/";
		$scaling = "Scale Proportionally";
		$overlay = "tenseconds";
		
		my @ent = split(/\|/,$scheduled);
		my $num = scalar(@ent);
		
		$itemfive = "$ent[5]";		
		$itemfive =~ s/\n//gi;
		
		if ($num < 7)
		{			
			$newEntry = "$ent[0]|$ent[1]|$ent[2]|$ent[3]|$ent[4]|$itemfive|$local_movie_path|$overlay|$scaling|\n";
		}
		else 
		{
			$itemeight = "$ent[8]";		
			$itemeight =~ s/\n//gi;
			
			if ($ent[6] ne "path") { $local_movie_path = $ent[6]; }
			# if ($ent[7] ne "tenseconds") { $overlay = $ent[7]; }
			
			$newEntry = "$ent[0]|$ent[1]|$ent[2]|$ent[3]|$ent[4]|$itemfive|$local_movie_path|$overlay|$itemeight|\n";
		}
		
		
		$newSchedule = $newSchedule . $newEntry;
		
		
	}
	
	$newSchedule =~ s/\n\n/\n/gi;
	open(BFILE, ">$schedpath.bak2") || print"Could not write backup schedule file.";
	print BFILE @sched;
	close (BFILE);
	
	open(NFILE, ">$schedpath") || print"Could not write to new schedule file.";
	print NFILE $newSchedule;
	close (NFILE);
	
	
}
#######################################################
## Subroutine to make new directories
#######################################################
sub makeNewDirectories {

	`mkdir /library/webserver/cgi-executables/exibia`;
	`mkdir /library/webserver/documents/exibia`;
	`mkdir /library/webserver/documents/exibia/movies`;
	`mkdir /library/webserver/documents/exibia/icons`;
	`mkdir /library/webserver/documents/exibia/movies/temp`;
	
	if (!-e "/library/webserver/cgi-executables/$temp_to/content/") { 
		`mkdir /library/webserver/cgi-executables/$temp_to/content`; }
	`chmod -R 775 /library/webserver/cgi-executables/$temp_to/content`;
	`chown -R www /library/webserver/cgi-executables/$temp_to/content`;

	if (!-e "/library/webserver/documents/$temp_to/previews/") { 
		`mkdir /library/webserver/documents/$temp_to/previews`; }
	`chmod -R 775 /library/webserver/documents/$temp_to/previews`;
	`chown -R www /library/webserver/documents/$temp_to/previews`;
	
	if (!-e "/library/webserver/documents/exibia/slides/") { 
		`mkdir /library/webserver/documents/exibia/slides`; }
	`chmod -R 775 /library/webserver/documents/exibia/slides`;
	`chown -R www /library/webserver/documents/exibia/slides`;

	if (!-e "/library/webserver/documents/exibia/backups/") { 
		`mkdir /library/webserver/documents/exibia/backups`; }
	`chmod -R 775 /library/webserver/documents/exibia/backups`;
	`chown -R www /library/webserver/documents/exibia/backups`;
	
	
	if (!-e "/library/webserver/cgi-executables/$temp_to/playlists/") { 
		`mkdir /library/webserver/cgi-executables/$temp_to/playlists`; }
	`chmod -R 775 /library/webserver/cgi-executables/$temp_to/playlists`;
	`chown -R www /library/webserver/cgi-executables/$temp_to/playlists`;

	if (!-e "/library/webserver/cgi-executables/$temp_to/playlists/instances/") { 
	`mkdir /library/webserver/cgi-executables/$temp_to/playlists/instances`; }
	`chmod -R 775 /library/webserver/cgi-executables/$temp_to/playlists/instances`;
	`chown -R www /library/webserver/cgi-executables/$temp_to/playlists/instances`;
	
	#	`touch /library/webserver/cgi-executables/$temp_to/localimages.txt`;
	#	`chmod -R 775 /library/webserver/cgi-executables/$temp_to/localimages.txt`;
	#	`chown -R www /library/webserver/cgi-executables/$temp_to/localimages.txt`;

	`touch /library/webserver/cgi-executables/$temp_to/playlists/defaultplaylist.txt`;
	`chmod -R 775 /library/webserver/cgi-executables/$temp_to/playlists/defaultplaylist.txt`;
	`chown -R www /library/webserver/cgi-executables/$temp_to/playlists/defaultplaylist.txt`;
	
	`touch /library/webserver/cgi-executables/$temp_to/playlists/playlist_index.txt`;
	`chmod -R 775 /library/webserver/cgi-executables/$temp_to/playlists/playlist_index.txt`;
	`chown -R www /library/webserver/cgi-executables/$temp_to/playlists/playlist_index.txt`;
	
	`touch /library/webserver/cgi-executables/$temp_to/exibia_two.log`;
	`chmod -R 775 /library/webserver/cgi-executables/$temp_to/exibia_two.log`;
	`chown -R www /library/webserver/cgi-executables/$temp_to/exibia_two.log`;
	
	`touch /library/webserver/cgi-executables/$temp_to/localimages.txt`;
	`chmod -R 775 /library/webserver/cgi-executables/$temp_to/localimages.txt`;
	`chown -R www /library/webserver/cgi-executables/$temp_to/localimages.txt`;
	
	`touch /library/webserver/cgi-executables/$temp_to/thumbnail_db.txt`;
	`chmod -R 775 /library/webserver/cgi-executables/$temp_to/thumbnail_db.txt`;
	`chown -R www /library/webserver/cgi-executables/$temp_to/thumbnail_db.txt`;
	
	`touch /library/webserver/cgi-executables/$temp_to/queue.txt`;
	`chmod -R 775 /library/webserver/cgi-executables/$temp_to/queue.txt`;
	`chown -R www /library/webserver/cgi-executables/$temp_to/queue.txt`;
	
	&statusUpdate("New Exibia 2.0 Directories Created"); 

}

#######################################################
# Subroutine to create a some preview thumbnails
#######################################################
sub createThumbs {
	
	if ($debug eq "yes") { return(); }
	
	$local_movies_thm = "";
	$number_of_previews = 9;
	$path_to_previews = "/Library/WebServer/Documents/$temp_to/previews";
	
	$loc_qt_filename = $_[0];
	$encoded_fn_for_refresh = $loc_qt_filename;
	$loc_qt_filename =~ s/\%([A-Fa-f0-9]{2})/pack('C', hex($1))/seg;	

	return if !($loc_qt_filename); 
	
	if ($debug eq "yes") {
		return if ($loc_qt_filename =~ m/.asf/);
		return if ($loc_qt_filename =~ m/.wmv/);
	}
	
	# New in build 134
	my @extension = split(/\./,$loc_qt_filename);
	my $ext = $extension[-1];
	my $full_ext = ".$ext";
	
	my	$fn_only = $f_to_check;
	$fn_only =~ s/$full_ext$//;
	
	foreach $existingThumb (@loc_tmb_db) {
		@tmb_line = split (/\|/,$existingThumb);
		$to_czech = $tmb_line[2];
		$to_czech =~ s/\n//gi;
		$to_czech =~ s/\(/\\(/gi;
		$to_czech =~ s/\)/\\)/gi;
		# if ($loc_qt_filename =~ m/$to_czech/i) { return($tmb_line[1]);	}
		if ($fn_only eq $to_czech) { return($tmb_line[1]);	}
	}

	$time_rn = time;
	
	## 1.3.5
	my @extension = split(/\./,$loc_qt_filename);
	my $ext = $extension[-1];
	
	my	$full_ext = ".$ext";
	my	$onlyName = $loc_qt_filename;
	$onlyName =~ s/$full_ext$//gi;
	
	my $now = $onlyName;

		$rand = int(rand(time)); 	$rnd_string = $rand . int(rand(time));
		$rnd_string = $rnd_string . int(rand(time));	$rnd_string = $rnd_string . int(rand(time));
		$rnd_string = $rnd_string . int(rand(time)); 	$fn_rand = substr($rnd_string,3,5);	
		
		$thumb_db_name = $time_rn . "_t" . $fn_rand;
				
		$test_now = $path_to_previews . "/" . $thumb_db_name . "_1.jpg";
		if (-e $test_now) {  print"$test_now = found\n"; return;}
		
		$check_for_thumb = $thumb_db_name;
		$loc_qt_filename = "/library/webserver/documents/exibia/movies/" . $loc_qt_filename;
		
		$x_size = "320"; if ($x_size) { $x_pixels = "-Z " . "$x_size "; }


		$thumb_db_loc = "/library/webserver/cgi-executables/$temp_to/thumbnail_db.txt";
		open(THUMBDB, ">>$thumb_db_loc") || print "Could not open thumbnail database file.";
		print THUMBDB "$time_rn|$thumb_db_name|$now\n";
		close (THUMBDB);
		
		$now = $thumb_db_name;
		
		$qt_info = "/library/webserver/cgi-executables/./exibia_qt \"$local_movies_thm/$loc_qt_filename\""; 
		
		@get_qt_info = `$qt_info`;
		$track_line = 0; $media_line = 0;


		foreach $line (@get_qt_info) {
			if ($line =~ m/track duration/) { $track_line++; $qt_duration = $line; }
		}
	
		$duration = 0;
		$preview_num = 0;
	
		if ($qt_duration =~ /\:(.*)\(/) {	$file_duration_string = $1; $duration = int($file_duration_string + 1); }
	
			if ($duration == 0) { return("audio"); }
			else {	  }

	
		if (!-e "/tmp/e2") { `mkdir /tmp/e2`; }
		
		$tmp_path_to_previews = "/tmp/e2";
		
		$time_offset = ($duration/$number_of_previews);
		
		until ($preview_num eq $number_of_previews) {
			$worked ="";
			
			$preview_num++;
			$durnum =(960*$preview_num);
			my $preview_thumbnail_time = int(($duration/($number_of_previews/$preview_num))-$time_offset);	
			my $preview_thumbnail_time_nonint = (($duration/($number_of_previews/$preview_num))-$time_offset);	
			my $generate_preview = "/library/webserver/cgi-executables/./exibia_qt_pic --exporter=BMPf,.... \"$local_movies_thm/$loc_qt_filename\" \"$tmp_path_to_previews/$now" . "_" . "$preview_num" . ".bmp\" --duration=$preview_thumbnail_time,$durnum"; 
			# print $generate_preview;
			my $do_it = `$generate_preview`;
			
			my $convert = "sips -s format jpeg \"$tmp_path_to_previews/$now" . "_" . "$preview_num" . ".bmp\" $x_pixels --out \"$tmp_path_to_previews/$now" . "_" . "$preview_num" . ".jpg\"";
			my $convert_it = `$convert`;
			
			my $copy = "cp \"$tmp_path_to_previews/$now" . "_" . "$preview_num" . ".jpg\" \"$path_to_previews/$now" . "_" . "$preview_num" . ".jpg\"";
			my $copy_it = `$copy`;
			
			my $remove = "rm \"$tmp_path_to_previews/$now" . "_" . "$preview_num" . ".bmp\"";
			my $remove_jpg = "rm \"$tmp_path_to_previews/$now" . "_" . "$preview_num" . ".jpg\"";
			
			# print $generate_preview . "\n";
			# print $convert . "\n";
			
			my $remove_it = `$remove`;
			my $remove_it_too = `$remove_jpg`;
			# print $remove . "\n";
		}

	my $returnMe = $now . "_" . $preview_num;
	chop($returnMe); chop($returnMe);
	return($returnMe); 

}

#######################################################
## Subroutine to log events to installer log
#######################################################
sub logEvent {
	my $status = $_[0];
	#`echo >>/tmp/exibia2installer.txt "$status"`;
	
	my $loctime = time;
	my $status_to_print = "$loctime|$status\n";
	
	open(LOGF, ">>/tmp/$install_log_date.txt");
	print LOGF "$status_to_print";
	close (LOGF);
	
	return();
}


#######################################################
## Subroutine to write to "Status File"
#######################################################
sub statusUpdate {
	my $status = $_[0];
	#`echo >>/tmp/exibia2installer.txt "$status"`;
	
	$on_step++;
	
	open(STATUS, ">>/tmp/exibia2installer.txt");
	print STATUS "$status\n";
	close (STATUS);
	
	open(STATUS, ">/tmp/exibia2progress_finish.txt");
	print STATUS "$on_step";
	close (STATUS);
	
	return();
}

#######################################################
# Bytes to Megabytes or Gigabytes
#######################################################
sub bytes {
	
	my $base = 1024;
	my $bytes = $_[0];
	if ($_[1]) { $base = $_[1]; }
	
	my $mbytes = "";
	
	if ($bytes > ($base * $base * $base)) {	$mbytes = (int((($bytes / $base) / $base / $base) * 100) / 100) . " GB"; }
	else { $mbytes = (int((($bytes / $base) / $base) * 100) / 100) . " MB"; }
	
	return($mbytes);
	
}

#######################################################
# Return a random six character string
#######################################################
sub qchar { 
	my $x = 0;
	
	my $char_string;
	
	until ($x == 6) {
		my $rand = int(rand(26))+65;
		$x++; 
		$char_string = $char_string . pack("c", $rand);
	}
	
	return $char_string;
}
